<?php
/**
 * @version     1.0.0
 * @package     com_fourdem
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Sushilkishan <sushilkishan@gmail.com> - http://sushilkishan.com
 */



defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.controller');
jimport('joomla.application.module.helper' );

JLoader::discover('FourdemSyncer', JPATH_COMPONENT_ADMINISTRATOR . '/libraries/syncer');

/**
 * Class FourdemControllerSync
 *
 * @since  1.2
 */
class FourdemControllerSyncsusers extends FourdemController
{
	/**
	 * Initialize the sync process
	 *
	 * @return void
	 */
		public function start()
	{
		// Check for a valid token. If invalid, send a 403 with the error message.
		JSession::checkToken('request') or $this->sendResponse(new Exception(JText::_('JINVALID_TOKEN'), 403));

		// Put in a buffer to silence noise.
		ob_start();

		// Initiate an empty state
		
		FourdemSyncerState::resetState();
		
		$state = FourdemSyncerState::getState();
		
		$input = JFactory::getApplication()->input;
		
		//$users = $input->getString('users');
		
		//$list = $input->getString('list');
		
		$chimp = new FourdemHelperChimp;

		
	
		
		
		
		
		
		########### User Data  Synchronize Start ###################
		
		$plugin = JPluginHelper::getPlugin('user', 'fourdem');
		$params = new JRegistry($plugin->params);
		$list_id  = $params->get('listid');		
		$toppings = $params->get('toppings');
		$fieldsvalue  = (array)$params->get('toppings');	
		$fieldKeyValue = array();
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		

		$query->select('*');
		$query->from('`#__users` AS `us`');
		$query->join('inner', '`#__fourdem_register` AS `rg` ON rg.user_id = us.id');
		$query->where('rg.status = 1');

		$db->setQuery($query);		
		$query_result = $db->loadObjectList();	
		
		foreach($query_result as $user_data)
		{
			$queryupdate = $db->getQuery(true);
			$queryUser = $db->getQuery(true);
			$paramsVar =json_decode($user_data->params);		
			$paramsVarArray = (array)json_decode($user_data->params);	
			//$paramsGroup = (array)$paramsVar->groups;
			
			if(is_array($fieldsvalue))
			{
				foreach($fieldsvalue as $fkey=>$fvalue)
				{
					if($fvalue)
					{
						
						if($paramsVarArray[$fkey])
						{
								echo $fvalue.'--'.$fkey.'<br>';
							$fieldKeyValue[$fvalue] = $paramsVarArray[$fkey];				
						}				
					}
				}
			}
			$paramsGroup = (array)$fieldKeyValue;
			

			
			$queryUser->select("*")->from("#__fourdem_register")->where(
				"user_id = " . $db->quote($user_data->user_id)
			);
			$db->setQuery($queryUser);
			$res = $db->loadObject();
			$recordStatus ="";
			$listStats = $chimp->SubscriberLists($list_id);
			
		
		
			$listSubscriberFound = "No";
			//$user = JFactory::getUser($user_data->user_id);
			if($listStats['total']>0)
			{
				if(is_array($listStats['data']))
				{
					foreach ($listStats['data'] as $key => $list)
					{
						$list  = (array)$list;							
						if (in_array($res->subscriber_id,$list)) {
							$listSubscriberFound= "yes";
							
						}
					}
				}
			}
			
			




		
			if ($res == null || ($res->subscriber_id =='' || $res->subscriber_id=='0') || $listSubscriberFound=='No')
			{
				$recordStatus ="insert";
				// Double OPTIN false
				$result = (object)$chimp->listSubscribe($list_id, $paramsVar->email, $paramsGroup, 'html', true, true, true, false);
			}
			else
			{
				$recordStatus ="update";
				$result = (object)$chimp->listSubscribeUpdate($list_id, $paramsVar->email, $paramsGroup, 'html', true, true, true, false,$res->subscriber_id);				
			}



			if($result->SubscriberID)
			{			
				$queryupdate->update('#__fourdem_register')->set('subscriber_id = ' . $db->quote($result->SubscriberID))
					->where('id = ' . $db->quote($res->id));				
				$db->setQuery($queryupdate);
				$db->execute();								
			}



		}
		

		########### User Data  Synchronize End ###################
		

		
		########### NewsLetter Data  Synchronize Start ###################		
		//$module = JModuleHelper::getModule('fourdem');
		$module    = 'mod_fourdem';
		$title     = '';
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);

		$query->select('m.params')
			->from('#__modules AS m')
			->where('m.module=' . $db->quote('mod_fourdem'));
		$db->setQuery($query);
		$module = $db->loadObject();

		$module_params = new JRegistry();
		$module_params->loadString($module->params);	
				
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('*');
		$query->from('`#__fourdem_users` AS `us`');
		
		$db->setQuery($query);
		$query_result = $db->loadObjectList();		
		$uArray = array();
		$mergeVars = array();
		foreach($query_result as $ids)
		{
			echo $emails_ids = $ids->email;
			$lists_id   = $ids->list_id;			
			$mergeVars  = json_decode($ids->merges);
			$mergeVars  = (array)$mergeVars;			
			$errors = $chimp->listSubscribe($lists_id, $emails_ids, $mergeVars, 'html', true, true, true, false);			
		}
		########### NewsLetter Data  Synchronize End ###################
			
		

		$state->header = JText::_('COM_FOURDEM_SYNC_COMPLETE');
		$state->message = '<div class="alert alert-info">' . JText::_('COM_FOURDEM_SYNC_COMPLETE_DESC') . '</div>';
		$this->sendResponse($state);	
	}
 
	 


	/**
	 * Syncs the users of the list
	 *
	 * @return void
	 */
	public function batch()
	{
		// Check for a valid token. If invalid, send a 403 with the error message.
		JSession::checkToken('request') or $this->sendResponse(new Exception(JText::_('JINVALID_TOKEN'), 403));

		// Put in a buffer to silence noise.
		ob_start();

		// Remove the script time limit.
		@set_time_limit(0);

		$state = FourdemSyncerState::getState();

		$chimp = new FourdemHelperChimp;

		//$members = $chimp->listMembers($state->lists[0]['mc_id'], 'subscribed', null, $state->offset, $state->batchSize);

		//FourdemHelperUsers::save($members['data'], $state->lists[0]['id'], $state->lists[0]['mc_id']);

		$pages = $state->lists[0]['toSync'] / $state->batchSize;

		if ($state->offset < $pages)
		{
			$state->offset = $state->offset + 1;
			$state->header = JText::sprintf('COM_FOURDEM_BATCH_SYNC_IN_LIST', $state->lists[0]['name']);
			$state->message = JText::sprintf('COM_FOURDEM_BATCH_SYNC_PROGRESS', $state->offset * $state->batchSize, $state->batchSize);
		}

		if ($state->offset > $pages)
		{
			// First list in the array was synced, lets remove it
			$oldList = array_shift($state->lists);

			// If we still have lists, then let us reset the offset
			if (count($state->lists))
			{
				$state->header = JText::sprintf('COM_FOURDEM_BATCH_SYNC_IN_OLD_LIST_COMPLETE', $oldList['name']);
				$state->message = JText::sprintf('COM_FOURDEM_BATCH_SYNC_IN_OLD_LIST_COMPLETE_DESC', $oldList['toSync'], $oldList['name'], $state->lists[0]['name']);

				$state->offset = 0;
			}
			else
			{
				$state->header = JText::_('COM_FOURDEM_SYNC_COMPLETE');
				$state->message = '<div class="alert alert-info">' . JText::_('COM_FOURDEM_SYNC_COMPLETE_DESC') . '</div>';

			}
		}

		FourdemSyncerState::setState($state);

		$this->sendResponse($state);
	}

	/**
	 * Method to handle a send a JSON response. The body parameter
	 * can be a Exception object for when an error has occurred or
	 * a JObject for a good response.
	 *
	 * @param   mixed  $data  JObject on success, Exception on error. [optional]
	 *
	 * @return  void
	 *
	 * @since   2.51.2
	 */
	public static function sendResponse($data = null)
	{
		// Send the assigned error code if we are catching an exception.
		if ($data instanceof Exception)
		{
			JLog::add($data->getMessage(), JLog::ERROR);
			JResponse::setHeader('status', $data->getCode());
			JResponse::sendHeaders();
		}

		// Create the response object.
		$response = new FourdemSyncerResponse($data);

		// Add the buffer.
		$response->buffer = JDEBUG ? ob_get_contents() : ob_end_clean();

		// Send the JSON response.
		echo json_encode($response);

		// Close the application.
		JFactory::getApplication()->close();
	}
}
