<?php
/**
 * @version     1.0.0
 * @package     com_fourdem
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Sushilkishan <sushilkishan@gmail.com> - http://sushilkishan.com
 */

// No direct access
defined('_JEXEC') or die;

/**
 * Fourdem helper.
 */
class FourdemHelper
{
	/**
	 * Configure the Linkbar.
	 */
	public static function addSubmenu($vName = '')
	{
		JSubMenuHelper::addEntry(
			JText::_('COM_FOURDEM_TITLE_CPANELS'),
			'index.php?option=com_fourdem&view=cpanels',
			$vName == 'cpanels'
		);
		JSubMenuHelper::addEntry(
			JText::_('COM_FOURDEM_TITLE_LISTS'),
			'index.php?option=com_fourdem&view=lists',
			$vName == 'lists'
		);
		JSubMenuHelper::addEntry(
			JText::_('COM_FOURDEM_TITLE_USERS'),
			'index.php?option=com_fourdem&view=users',
			$vName == 'users'
		);


	}

	/**
	 * Gets a list of the actions that can be performed.
	 *
	 * @return	JObject
	 * @since	1.6
	 */
	public static function getActions()
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		$assetName = 'com_fourdem';

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.own', 'core.edit.state', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action, $user->authorise($action, $assetName));
		}

		return $result;
	}
}
