<?php
/**
 * @package    fourDem
 * @author     Sushil Kishan
 * @date       26.11.13
 *
 * @copyright  Copyright (C) 2008 - 2013  . All rights reserved.
 * @license    GNU General Public License version 2 or later; see LICENSE
 */

defined('_JEXEC') or die('Restricted access');

define('_CPLG_JOOMLA', 0);
define('_CPLG_CB', 1);
define('_CPLG_JOMSOCIAL', 2);

/**
 * Helper class for Registration plugins
 * Class FourdemHelperRegistration
 *
 * @since  1.4
 */
class FourdemHelperRegistration
{
	private static $instance;

	/**
	 * Temporary saves the user merge_vars after the registration, no processing
	 * Does not check if user E-Mail already exists (this has to be done before!)
	 *
	 * @param   object  $user      - joomla user obj
	 * @param   array   $postdata  - only fourdem data
	 * @param   int     $plg       - which plugin triggerd the save method
	 *
	 * @return void
	 */
	public static function saveTempUser($user, $postdata, $plg = _CPLG_JOOMLA)
	{
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		$queryuUpdate = $db->getQuery(true);
		$postdata['OPTINIP'] = $_SERVER['REMOTE_ADDR'];
		if (isset($postdata['fourdem_groups']))
		{
			$postdata['groups'] = $postdata['fourdem_groups'];
			unset($postdata['fourdem_groups']);
		}
		if (isset($postdata['fourdem_interests']))
		{
			$postdata['interests'] = $postdata['fourdem_interests'];
			unset($postdata['fourdem_interests']);
		}
		$querySlect = "SELECT * FROM `#__fourdem_register`
						WHERE user_id =".$user->id;
		$db->setQuery($querySlect);
		$QueryResult = $db->loadObjectList();
		if(count($QueryResult)>0)
		{
			$queryuUpdate->update('#__fourdem_register')->set('params = ' . $db->quote(json_encode($postdata)))
				->where('user_id = ' . $db->quote($user->id));				
			$db->setQuery($queryuUpdate);
			$db->execute();
			//echo $queryuUpdate;
		}
		else
		{		
			$query->insert("#__fourdem_register")->columns("user_id, params, plg, created")
				->values(
					$db->quote($user->id) . ',' . $db->quote(json_encode($postdata))
					. ',' . $db->quote($plg) . ',' . $db->quote(JFactory::getDate()->toSql())
			);
			$db->setQuery($query);
			$db->execute();
			//echo $query;
		}
		//die();
	}

	/**
	 * Directly activates the user with Mailfourdem
	 *
	 * @param   object  $user    - The Joomla user Object
	 * @param   object  $params  - The fourdem post data
	 * @param   int     $plg     - Which plugin triggerd the save method
	 *
	 * @return  bool
	 */
	public static function activateDirectUser($user, $params, $plg = _CPLG_JOOMLA)
	{
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		$queryuInsert = $db->getQuery(true);
		$queryuUpdate = $db->getQuery(true);
		$chimp = new fourdemHelperChimp;

		//		$userlists = $chimp->listsForEmail($user->email);

		// Hidden field
		$listId = $params['list-id'];

		/*
		if ($userlists && in_array($listId, $userlists))
		{
			// Already in list, TODO update subscription here
			return null;
		}
		*/
		$user->email =$params['email'];
		$customFieldList = $chimp->getCustomFiledsListById($listId);
		$cFields = array();
		$mergeVarsa = array();
		if(isset($customFieldList['total']) && $customFieldList['total']>0)
		{
			foreach($customFieldList['data'] as $values)
			{
				if($values->FieldName=='First Name')
				{
					$mergeVars[$values->CustomFieldID] = $user->name;
				}
			}
			//$mergeVars[$value] = $parts[0];
		}
		
		
		// Activate E-Mail in mailfourdem
		if (isset($params['groups']))
		{
			foreach ($params['groups'] as $key => $group)
			{
				$mergeVars[$key] = $group;
			}
		}	

		//$mergeVars['OPTINIP'] = $_SERVER['REMOTE_ADDR'];
		
		$query->select("*")->from("#__fourdem_register")->where(
			"user_id = " . $db->quote($user->id)
		);
		
		$db->setQuery($query);
		//$res = $db->loadObject();
		$res = $db->loadObjectList();		
		$recordStatus ="";		
		if(count($res)>0)
		{
			$rows = $res[0];		
			if(!empty($rows->subscriber_id))
			{
				//echo 'Not Empty Update Code';
				$recordStatus ="update";
				$result = (object)$chimp->listSubscribeUpdate($listId, $user->email, $mergeVars, 'html', true, true, true, false,$rows->subscriber_id);
			}
			else
			{
				//echo 'Empty Insert Code';
				$recordStatus ="insert";				
				$result = (object)$chimp->listSubscribe($listId, $user->email, $mergeVars, 'html', true, true, true, false);
			}
		}
		else
		{
			$rows = $res[0];		
			if(!empty($rows->subscriber_id))
			{
				//echo 'Not Empty Update Code';
				$recordStatus ="update";
				$result = (object)$chimp->listSubscribeUpdate($listId, $user->email, $mergeVars, 'html', true, true, true, false,$rows->subscriber_id);
			}
			else
			{
				//echo 'Empty Insert Code';
				$recordStatus ="insert";				
				$result = (object)$chimp->listSubscribe($listId, $user->email, $mergeVars, 'html', true, true, true, false);
			}
		}
		
		if (!$result->errorCode)
		{
			if($recordStatus =="insert")
			{
				$querySlect = "SELECT * FROM `#__fourdem_register`
						WHERE user_id =".$user->id;
				$db->setQuery($querySlect);
				$QueryResult = $db->loadObjectList();
				if(count($QueryResult)>0)
				{				
					$queryuUpdate->update($db->quoteName('#__fourdem_register'))
							->set('params = ' . $db->quote(json_encode($params)))
							->set('subscriber_id = ' . $db->quote($result->SubscriberID))
							->where('user_id = ' . $db->quote($user->id) );					
					$db->setQuery($queryuUpdate);
					$db->execute();
					//echo $queryuUpdate;
				}
				else
				{		
					$queryuInsert->insert("#__fourdem_register")->columns("user_id, params, plg, created,subscriber_id, status")
					->values(
						$db->quote($user->id) . ',' . $db->quote(json_encode($params))
						. ',' . $db->quote($plg) . ',' . $db->quote(JFactory::getDate()->toSql()). ',' . $db->quote($result->SubscriberID).',1'
					);
					$db->setQuery($queryuInsert);
					$db->execute();
					//echo $query;
				}
			}
			else
			{
				$querySlect = "SELECT * FROM `#__fourdem_register`
						WHERE user_id =".$user->id;
				$db->setQuery($querySlect);
				$QueryResult = $db->loadObjectList();
				if(count($QueryResult)>0)
				{				
					$queryuUpdate->update($db->quoteName('#__fourdem_register'))
							->set('params = ' . $db->quote(json_encode($params)))
							->set('subscriber_id = ' . $db->quote($result->SubscriberID))
							->where('user_id = ' . $db->quote($user->id) );					
					$db->setQuery($queryuUpdate);
					$db->execute();
					//echo $queryuUpdate;
				}
				else
				{		
					$queryuInsert->insert("#__fourdem_register")->columns("user_id, params, plg, created,subscriber_id, status")
					->values(
						$db->quote($user->id) . ',' . $db->quote(json_encode($params))
						. ',' . $db->quote($plg) . ',' . $db->quote(JFactory::getDate()->toSql()). ',' . $db->quote($result->SubscriberID).',1'
					);
					$db->setQuery($queryuInsert);
					$db->execute();
					//echo $query;
				}
			}
		}
		else
		{
			JFactory::getApplication()->enqueueMessage(JText::_('COM_FOURDEM_YOU_WERE_NOT_SUBSCRIBED_TO_NEWSLETTER') . ':' . $chimp->errorMessage);
			return false;
		}
		return true;
	}

	/**
	 * Activates the temporary user, checks if user is in the temporary table
	 * and also checks if the E-Mail address is already activated
	 *
	 * @param   object  $user  - the users data
	 *
	 * @return  boolean
	 */
	public static function activateTempUser($user)
	{
		// Check if user wants newsletter and is in our temp table
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);

		$query->select("*")->from("#__fourdem_register")->where(
			"user_id = " . $db->quote($user->id)
		);

		$db->setQuery($query);

		$res = $db->loadObject();

		if ($res == null)
		{
			// Nothing to delete
			return null;
		}

		// Check if user is already activated
		// We want a assoc array here
		$params = json_decode($res->params, true);

		$chimp = new fourdemHelperChimp;

		//$userlists = $chimp->listsForEmail($user->email);

		// Hidden field
		$listId = $params['listid'];

		/*
		if ($userlists && in_array($listId, $userlists))
		{
			// Already in list, we don't update here, we update on form send
			return null;
		}
		*/

		// Activate E-Mail in mailfourdem
		if (isset($params['groups']))
		{
			foreach ($params['groups'] as $key => $group)
			{
				$mergeVars[$key] = $group;
			}
		}

		if (isset($params['interests']))
		{
			foreach ($params['interests'] as $key => $interest)
			{
				// Take care of interests that contain a comma (,)
				if (is_array($interest))
				{
					array_walk($interest, create_function('&$val', '$val = str_replace(",","\,",$val);'));
					$mergeVars['GROUPINGS'][] = array('id' => $key, 'groups' => implode(',', $interest));
				}
				else
				{
					$mergeVars['GROUPINGS'][] = array('id' => $key, 'groups' => $interest);
				}
			}
		}

		//$mergeVars['OPTINIP'] = $params['OPTINIP'];


		// Double OPTIN false
		
		$chimp->listSubscribe($listId, $user->email, $mergeVars, 'html', false, true, true, false);

		if (!$chimp->errorCode)
		{
			$query->update('#__fourdem_users')->set('merges = ' . $db->quote(json_encode($mergeVars)))
				->where('email = ' . $db->quote($user->email) . ' AND list_id = ' . $db->quote($listId));
			$db->setQuery($query);
			$db->execute();
		}
		else
		{
			JFactory::getApplication()->enqueueMessage(JText::_('COM_FOURDEM_YOU_WERE_NOT_SUBSCRIBED_TO_NEWSLETTER') . ':' . $chimp->errorMessage);

			return false;
		}

		return true;
	}

	/**
	 * Deletes users subscription, does check if the table exists before
	 *
	 * @param   object  $user  - The Joomla user object
	 *
	 * @return  boolean
	 */

	public static function deleteUser($user)
	{
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);

		// Check for email, more valid then id
		$query->select("*")->from("#__fourdem_users")->where(
			"email = " . $db->quote($user->email)
		);
		$db->setQuery($query);

		$res = $db->loadObject();

		if ($res == null)
		{
			// Nothing to delete
			return null;
		}

		$chimp = new fourdemHelperChimp;
		$userlists = $chimp->listsForEmail($user->email);

		if ($userlists && in_array($res->list_id, $userlists))
		{
			$chimp->listUnsubscribe($res->list_id, $user->email, false, false, true);
		}

		return true;
	}

	/**
	 * Updates an existing subscription
	 *
	 * @param   JUser  $user      - The JUser Obj
	 * @param   array  $postdata  - The params
	 *
	 * @return  boolean
	 */
	public static function updateSubscription($user, $postdata)
	{
		// We just update the users subscription to mailfourdem (not db checking here)
		if (isset($postdata['fourdem_groups']))
		{
			$postdata['groups'] = $postdata['fourdem_groups'];
			unset($postdata['fourdem_groups']);
		}

		if (isset($postdata['fourdem_interests']))
		{
			$postdata['interests'] = $postdata['fourdem_interests'];
			unset($postdata['fourdem_interests']);
		}

		$chimp = new fourdemHelperChimp;

		$userlists = $chimp->listsForEmail($user->email);

		// Hidden field
		$listId = $postdata['listid'];

		if ($userlists && in_array($listId, $userlists))
		{
			// Already in list, we don't update here, we update on form send
			return null;
		}

		// Activate E-Mail in mailfourdem
		if (isset($params['groups']))
		{
			foreach ($params['groups'] as $key => $group)
			{
				$mergeVars[$key] = $group;
			}
		}

		// Interests
		if (isset($params['interests']))
		{
			foreach ($params['interests'] as $key => $interest)
			{
				// Take care of interests that contain a comma (,)
				array_walk($interest, create_function('&$val', '$val = str_replace(",","\,",$val);'));
				$mergeVars['GROUPINGS'][] = array('id' => $key, 'groups' => implode(',', $interest));
			}
		}

		$chimp->listSubscribe($listId, $user->email, $mergeVars, 'html', false, true, true, false);

		if (!$chimp->errorCode)
		{
			return true;
		}
		else
		{
			echo "Error: " . $chimp->errorMessage;

			return false;
		}
	}

	/**
	 * Checks if the user is already subscribed to the list
	 *
	 * @param   string  $listId  - The listid
	 * @param   string  $email   - The E-Mail
	 *
	 * @return bool
	 */

	public static function isSubscribed($listId, $email)
	{
		// Check if user email already registered
		$chimp = new fourdemHelperChimp;

		$userlists = $chimp->listsForEmail($email);

		if ($userlists && in_array($listId, $userlists))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
}
