<?php
/**
 * @version     1.0.0
 * @package     com_fourdem
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Sushilkishan <sushilkishan@gmail.com> - http://sushilkishan.com
 */
defined('_JEXEC') or die('Restricted access');

/**
 * Class FourdemField
 *
 * @since  1.0
 */
abstract class FourdemField extends JFormField
{
	/**
	 * The constructor
	 *
	 * @param   object  $form  The form to attach to the form field object.
	 */
	public function __construct($form = null)
	{
		parent::__construct($form);

		$this->checkFourdemInstall();
	}

	/**
	 * Checks if com_fourdem is installed
	 *
	 * @return void
	 */
	public function checkFourdemInstall()
	{
		
		$params = JComponentHelper::getParams('com_fourdem');
		$api_username = $params->get("api_username", '');
		$api_password = $params->get("api_password", '');
		$api_url = $params->get("api_url", '');

		if (empty($api_username) && empty($api_password) && empty($api_url))
		{
			$appl = JFactory::getApplication();
			$appl->redirect('index.php?option=com_fourdem', JText::_('MOD_FOURDEM_YOU_NEED_TO_PROVIDE_API_KEY'));
		}
		
	}

	/**
	 * Gets component settings
	 *
	 * @param   string  $key      - setting name
	 * @param   string  $default  - default value
	 *
	 * @return mixed
	 */
	public function getSettings($key, $default = '')
	{
		return JComponentHelper::getParams('com_fourdem')->get($key, $default);
	}
}
