<?php
/**
 * @version     1.0.0
 * @package     com_fourdem
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Sushilkishan <sushilkishan@gmail.com> - http://sushilkishan.com
 */

defined('_JEXEC') or die('Restricted access');
JLoader::register('FourdemField', JPATH_ADMINISTRATOR . '/components/com_fourdem/models/fields/field.php');
JLoader::register('FOURDEMAPI', JPATH_COMPONENT_ADMINISTRATOR . '/libraries/fourdem/FOURDEM.class.php');

/**
 * Class JFormFieldFields
 *
 * @since  1.0
 */
class JFormFieldFields extends FourdemField
{
	/**
	 * Method to get the field input markup.
	 *
	 * @return string
	 */
	public function getInput()
	{
		$listid = $this->form->getValue('listid', 'params');
		$api = new fourdemHelperChimp;
		$fields = $api->listMergeVars($listid);
		
		
		$key = 'CustomFieldID';
		$val = 'FieldName';
		$options = false;

		if ($fields)
		{
			
			if(is_array($fields['data']))
			{
			
			foreach ($fields['data'] as $field)
			{
				$field = (array)$field;

				
			
				$choices = '';
				//$field = (array)$field;
				
				
				if (isset($field['choices']))
				{
					
					foreach ($field['choices'] as $c=>$d)
					{
						$choices .= $c.'@@'.$d.'##';
					}

					$choices = substr($choices, 0, -2);
				}

				$req = ($field['IsRequired']) ? 1 : 0;

				if ($req)
				{
					$options[] = array($key => $field[$key] . ';' . $field['FieldType'] . ';' . $field['FieldName']
						. ';' . $req . ';' . $choices, $val => $field[$val] . "*"
					);
				}
				else
				{
					$options[] = array($key => $field[$key] . ';' . $field['FieldType'] . ';' . $field['FieldName'] . ';' . $req . ';' . $choices, $val => $field[$val]);
				}
			}
		  }	
		}

		$attribs = 'multiple="multiple" size="8" class="chzn-done"';

		if ($options)
		{
			$content = JHtml::_('select.genericlist', $options, 'jform[params][fields][]', $attribs, $key, $val, $this->value, $this->id);
		}
		else
		{
			$content = '<div style="float:left;">' . JText::_('MOD_FOURDEM_NO_FIELDS') . '</div>';
		}

		return $content;
	}
}
