<?php
/**
 * @version     1.0.0
 * @package     com_fourdem
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Sushilkishan <sushilkishan@gmail.com> - http://sushilkishan.com
 */

defined('_JEXEC') or die('Restricted access');
JLoader::register('FourdemField', JPATH_ADMINISTRATOR . '/components/com_fourdem/models/fields/field.php');
JLoader::register('fourdemHelperChimp', JPATH_ADMINISTRATOR . '/components/com_fourdem/helpers/chimp.php');

/**
 * Class JFormFieldFourdemlists
 *
 * @since  1.2
 */
class JFormFieldfourdemlists extends FourdemField
{
	/**
	 * Method to get the field input markup.
	 *
	 * @return string
	 */
	public function getInput()
	{
		$api = new fourdemHelperChimp;
		$lists = $api->lists();

		$key = 'ListID';
		$val = 'Name';
		$options[] = array($key => '', $val => '-- ' . JText::_('MOD_FOURDEM_PLEASE_SELECT_A_LIST') . ' --');

		foreach ($lists['data'] as $list)
		{	
			$list = (array)$list;
			$options[] = array($key => $list[$key], $val => $list[$val]);
		}

		$option = JFactory::getApplication()->input->get('option');
		$controller = ($option == 'com_modules' ? 'module' : 'plugin');

		$attribs = "onchange='submitbutton(\"$controller.apply\")'";

		if ($options)
		{
			$content = JHtml::_('select.genericlist', $options, 'jform[params][listid]', $attribs, $key, $val, $this->value, $this->id);
		}

		return $content;
	}
}
