<?php
/**
 * @version     1.0.0
 * @package     com_fourdem
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Sushilkishan <sushilkishan@gmail.com> - http://sushilkishan.com
 */

// No direct access

defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.view');

/**
 * Class FourdemViewLists
 *
 * @since  1.0
 */
class FourdemViewLists extends JViewLegacy
{
	/**
	 * Displays the view
	 *
	 * @param   string  $tpl  - the layout
	 *
	 * @return mixed|void
	 */
	public function display($tpl = null)
	{
		$this->state = $this->get('State');
		$this->items = $this->get('Items');
		$this->pagination = $this->get('Pagination');

		$this->addToolbar();
		 
		$input = JFactory::getApplication()->input;
        $view = $input->getCmd('view', '');
        FourdemHelper::addSubmenu($view); 
		 
		parent::display($tpl);
	}

	/**
	 * Ads a toolbar to the page
	 *
	 * @return void
	 */
	
	protected function addToolbar()
	{
		require_once JPATH_COMPONENT.'/helpers/fourdem.php';

		$state	= $this->get('State');
		$canDo	= FourdemHelper::getActions($state->get('filter.category_id'));

		JToolBarHelper::title(JText::_('COM_FOURDEM_TITLE_LISTS'), 'lists.png');

			$document = JFactory::getDocument();
		$document->addStyleDeclaration('.icon-48-lists ' .
          '{background-image: url(../administrator/components/com_fourdem/assets/images/l_lists.png);}');
		
				$toolbar = JToolbar::getInstance('toolbar');
		$toolbar->appendButton(
			'Popup', 'archive', 'COM_FOURDEM_SYNC', 'index.php?option=com_fourdem&view=syncs&tmpl=component', 500, 300, 0, 0,
			'window.parent.location.reload()', 'COM_FOURDEM_SYNC_HEADING'
		);

		JToolBarHelper::title(JText::_('COM_FOURDEM_TITLE_LISTS'), 'lists');

		JToolBarHelper::deleteList(JText::_('COM_CMC_DO_YOU_WANT_TO_REMOVE_LIST'), 'lists.delete');
		



	}
	
	

	
}
