<?php
/**
 * @version     1.0.0
 * @package     com_fourdem
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Sushilkishan <sushilkishan@gmail.com> - http://sushilkishan.com
 */


defined('_JEXEC') or die('Restricted access');

JHtml::_('behavior.framework', 1);
jimport('joomla.filter.output');
JHTML::_('stylesheet', 'administrator/components/com_fourdem/assets/css/fourdem.css');
JHTML::_('script', 'administrator/components/com_fourdem/assets/js/sync.js');
JHtml::_('script', 'system/progressbar.js', true, true);

$chimp = new FourdemHelperChimp;

$lists = $chimp->lists();
?>
<script type="text/javascript">
	window.addEvent('domready', function() {
		new fourdemSync();
	});
</script>

<div id="fourdem-indexer-container">
	<h1 id="fourdem-progress-header"><?php echo JText::_('COM_FOURDEM_SYNCER_HEADER_INIT'); ?></h1>

	<p id="fourdem-progress-message"><?php echo JText::_('COM_FOURDEM_SYNCER_MESSAGE_INIT'); ?></p>

	<form id="fourdem-progress-form"></form>

	<div id="fourdem-progress-container"></div>

	<input id="fourdem-indexer-token" type="hidden" name="<?php echo JFactory::getSession()->getFormToken(); ?>" value="1" />
</div>

<?php if($lists['total'] > 0) : ?>

	<table class="table table-striped">
		<tr>
			<th>#</th>
			<th><?php echo JText::_('COM_FOURDEM_LIST_ID'); ?></th>
			<th><?php echo JText::_('COM_FOURDEM_LIST_NAME'); ?></th>
			<th><?php echo JText::_('COM_FOURDEM_LIST_MEMBER_COUNT'); ?></th>
		</tr>
		<?php foreach($lists['data'] as $list) : 
		
		

		?>
			<tr>
				<td><input type="checkbox" name="<?php echo $list->ListID; ?>" /></td>
				<td><?php echo $list->ListID; ?></td>
				<td><?php echo $list->Name; ?></td>
				<td><?php echo $list->SubscriberCount; ?></td>
			</tr>
		<?php endforeach; ?>
		<tr>
			<td colspan="3"></td>
			<td>
				<button class="btn" id="sync" class="disabled" disabled="disabled">
					<?php echo JText::_('COM_FOURDEM_SYNCHRONIZE'); ?>
				</button>
			</td>
		</tr>
	</table>

<?php else : ?>
	<?php echo JText::_('COM_FOURDEM_NO_LISTS_TO_SYNC'); ?>
<?php endif;?>
