<?php
/**
 * @version     1.0.0
 * @package     com_fourdem
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Sushilkishan <sushilkishan@gmail.com> - http://sushilkishan.com
 */

// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.view');

/**
 * View class for a list of Fourdem.
 */
class FourdemViewUsers extends JView
{
	protected $items;
	protected $pagination;
	protected $state;

	/**
	 * Display the view
	 */
	public function display($tpl = null)
	{
		$this->items		= $this->get('Items');
		$this->pagination	= $this->get('Pagination');
		$this->state		= $this->get('State');	
		
		


		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			throw new Exception(implode("\n", $errors));
		}
        
		$this->addToolbar();
        
        $input = JFactory::getApplication()->input;
        $view = $input->getCmd('view', '');
        FourdemHelper::addSubmenu($view);
        
		parent::display($tpl);
	}

	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	 
	  protected function addToolbar()
	{
		require_once JPATH_COMPONENT.'/helpers/fourdem.php';

		$state	= $this->get('State');
		$canDo	= FourdemHelper::getActions($state->get('filter.category_id'));

		JToolBarHelper::title(JText::_('COM_FOURDEM_TITLE_LISTS'), 'lists.png');

			$document = JFactory::getDocument();
		$document->addStyleDeclaration('.icon-48-lists ' .
          '{background-image: url(../administrator/components/com_fourdem/assets/images/l_users.png);}');
		
		$toolbar = JToolbar::getInstance('toolbar');

		$toolbar->appendButton(
			'Popup', 'archive', 'COM_FOURDEM_SYNC', 'index.php?option=com_fourdem&view=syncsusers&tmpl=component&footer=no', 500, 500, 0, 0,
			'window.parent.location.reload()', 'COM_FOURDEM_SYNC_HEADING'
		);

		JToolBarHelper::title(JText::_('COM_FOURDEM_TITLE_LISTS'), 'lists');

		//JToolBarHelper::deleteList(JText::_('COM_CMC_DO_YOU_WANT_TO_REMOVE_LIST'), 'lists.delete');
		



	}

}
