<?php
/**
 * @copyright	Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('JPATH_BASE') or die;

/**
 * Plugin class for logout redirect handling.
 *
 * @package		Joomla.Plugin
 * @subpackage	System.logout
 */
class plgSystemfourdemconf extends JPlugin
{
	/**
	 * Object Constructor.
	 *
	 * @access	public
	 * @param	object	The object to observe -- event dispatcher.
	 * @param	object	The configuration object for the plugin.
	 * @return	void
	 * @since	1.5
	 */
	function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);		
	}

	/**
	 * This method should handle any logout logic and report back to the subject
	 *
	 * @param	array	$user		Holds the user data.
	 * @param	array	$options	Array holding options (client, ...).
	 *
	 * @return	object	True on success
	 * @since	1.5
	 */
	public function onConfigurationBeforeSave($user, $options = array(), $isNew)
	{
		$result = true;
		if (JFactory::getApplication()->isAdmin())
		{
			if($options->get('element')=='com_fourdem')
			{					
				JLoader::register('fourdemHelperChimp', JPATH_ADMINISTRATOR . '/components/com_fourdem/helpers/chimp.php');
				
				$registry = new JRegistry();
				$registry->loadString($options->params);
				$api_username = $registry->get('api_username');
				$api_password = $registry->get('api_password');
				$api_url 	  = $registry->get('api_url');				
				$api		  = new FourdemHelperChimp($api_username,$api_password,$api_url);
				$userCheck	  = $api->checkConnection();
				if(!$userCheck)
				{	             
					$msg = 'Invalid login information.';
					$options->setError($msg);
					//JError::raiseWarning(403, $msg);
					$result = false;					
				}
				else
				{
					echo '2';
					$result = true;	
				}			
			}
		}
		return $result;
	}
	 function onAfterRoute()
        {
					// Get the application object.
					$app = JFactory::getApplication();
					
					if ($app->isSite()) {
						// if this is the front end, see if this is a registration page
						if ( $app->input->get('option') == 'com_users' ) {
							$view = $app->input->get('view', '');
							$itemID = $app->input->get( 'Itemid', '' );
							// Look for a registration link to Joomla! User manager
							if ($view == 'registration') {
								$url = 'index.php?option=com_virtuemart&view=user';
								$menuid = (int) $this->params->get("menuid", 0);  // Get the menu id parameter								
								$app->redirect( JRoute::_( $url, false ), null, null, true, true );
							}
						}
					}
       	}
}