<?php
/**
 * @package    fourDem
 * @author     Sushil Kishan
 * @date       26.11.13
 *
 * @copyright  Copyright (C) 2008 - 2013  . All rights reserved.
 * @license    GNU General Public License version 2 or later; see LICENSE
 */

// No direct access
defined('_JEXEC') or die('Restricted access');

JLoader::discover('fourdemHelper', JPATH_ADMINISTRATOR . '/components/com_fourdem/helpers/');

/**
 * Class PlgUserFourdem
 *
 * @since  1.4
 */
class PlgUserfourDem extends JPlugin
{
	/**
	 * Prepares the form
	 *
	 * @param   string  $form  - the form
	 * @param   object  $data  - the data object
	 *
	 * @return bool
	 */

	public function onContentPrepareForm($form, $data)
	{

		if (!($form instanceof JForm))
		{
			$this->_subject->setError('JERROR_NOT_A_FORM');

			return false;
		}

		$needToValidate = true;

		// Check we are manipulating a valid form.
		$name = $form->getName();

		if (!in_array($name, array('com_users.registration')))
		{
			return true;
		}

		$input = JFactory::getApplication()->input;
		$task = $input->get('task');

		if (in_array($task, array('register', 'apply', 'save')))
		{
			$requestData = JFactory::getApplication()->input->get('jform', array(), 'array');
			$needToValidate = isset($requestData['fourdem']) && isset($requestData['fourdem']['newsletter']);
		}

		if ($needToValidate)
		{
			$lang = JFactory::getLanguage();
			$lang->load('plg_user_fourdem', JPATH_ADMINISTRATOR);

			JHtml::_('behavior.framework');
			JHtml::script('media/plg_user_fourdem/js/fourdem.js');
			
			
			$renderer = FourdemHelperXmlbuilder::getInstance($this->params);

			// Render Content
			$html = $renderer->build();

			// Inject fields into the form
			$form->load($html, false);
		}

		return true;
	}


	/**
	 * Prepares the form
	 *
	 * @param   object   $data    - the users data
	 * @param   boolean  $isNew   - is the user new
	 * @param   object   $result  - the db result
	 * @param   string   $error   - the error message
	 *
	 * @return   boolean
	 */

	public function onUserAfterSave($data, $isNew, $result, $error)
	{
	/*
		$db =  JFactory::getDBO();
		$userId = JArrayHelper::getValue($data, 'id', 0, 'int');		

		$autosync = $this->params->get('auto-sync');
		
		$toppings = $this->params->get('toppings');
		
		$listid       = $this->params->get('listid');
		
		$fieldsvalue  = (array)$this->params->get('toppings');		
		
		$fieldKeyValue = array();

		if($data['virtuemart_country_id'])
		{		
			$queryc = "SELECT country_name FROM `#__virtuemart_countries`
						WHERE virtuemart_country_id =".$data['virtuemart_country_id'];
			$db->setQuery($queryc);
			$countryname = $db->loadResult();
			$data['virtuemart_country_id'] = $countryname;
		}
		
		if($data['virtuemart_state_id'])
		{		
			$queryc = "SELECT state_name FROM `#__virtuemart_states`
						WHERE virtuemart_state_id =".$data['virtuemart_state_id'];
			$db->setQuery($queryc);
			$statename = $db->loadResult();
			$data['virtuemart_state_id'] = $statename;
		}

		if(is_array($fieldsvalue))
		{
			foreach($fieldsvalue as $fkey=>$fvalue)
			{
				if($fvalue)
				{
					if($data[$fkey])
					{
						$fieldKeyValue[$fvalue] = $data[$fkey];				
					}		
				}
			}
		}
		
		$data['list-id'] = $listid;
		
		$data['reg_fields'] = $toppings;	
		
		$data['groups'] = $fieldKeyValue;
		
		

		if ($userId && $result && $autosync=='1')
		{			
			if ($data["fourdem"]["newsletter"] != "1" && $isNew != false)
			{
				// Abort if Newsletter is not checked
				//return true;
			}

			$user = JFactory::getUser($data["id"]);
			
			// Directly activate user
			$activated = FourdemHelperRegistration::activateDirectUser(
				$user, $data, _CPLG_JOOMLA
			);		
		}
		else
		{	

			$user = JFactory::getUser($data["id"]);
			FourdemHelperRegistration::saveTempUser($user, $data, _CPLG_JOOMLA);
			// We only do something if the user is unblocked
			if ($data["block"] == 0)
			{
				// Checking if user exists etc. is taken place in activate function
				//FourdemHelperRegistration::activateTempUser(JFactory::getUser($data["id"]));
			}
		}
*/
		return true;
	}
	
	
	
	public function onUserAfterSave_OLD($data, $isNew, $result, $error)
	{
		$userId = JArrayHelper::getValue($data, 'id', 0, 'int');
		
		

		if ($userId && $result && isset($data['fourdem']) && (count($data['fourdem'])))
		{
			echo '1';
			
			if ($data["fourdem"]["newsletter"] != "1" && $isNew != false)
			{
				// Abort if Newsletter is not checked
				return true;
			}

			$user = JFactory::getUser($data["id"]);

			if ($data["block"] == 1)
			{
				echo '2';
				die();
				// Temporary save user
				FourdemHelperRegistration::saveTempUser($user, $data["fourdem"], _CPLG_JOOMLA);
			}
			else
			{
				
		
				if (!$isNew)
				{
						echo '3';
			//die();
					// Activate User to Mailfourdem
					FourdemHelperRegistration::activateTempUser($user);
				}
				else
				{
					
			
					// Directly activate user
					$activated = FourdemHelperRegistration::activateDirectUser(
						$user, $data["fourdem"], _CPLG_JOOMLA
					);

					if ($activated)
					{
						JFactory::getApplication()->enqueueMessage(JText::_('COM_FOURDEM_YOU_VE_BEEN_SUBSCRIBED_BUT_CONFIRMATION_IS_NEEDED'));
					}
				}
			}
		}
		else
		{
			
			echo '5';
			die();
			// We only do something if the user is unblocked
			if ($data["block"] == 0)
			{
				// Checking if user exists etc. is taken place in activate function
				FourdemHelperRegistration::activateTempUser(JFactory::getUser($data["id"]));
			}
		}
		echo '<pre>';
			print_r($userId);
		echo '</pre>';
		
		die();
		return true;
	}
	
}
