<?php
/**
 * @version     1.0.0
 * @package     com_fourdem
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Sushilkishan <sushilkishan@gmail.com> - http://sushilkishan.com
 */

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controllerlegacy');

/**
 * Class FourdemControllerSubscription
 *
 * @since  1.0
 */
class FourdemControllerSubscription extends JControllerLegacy
{
	/**
	 * Save the subscription
	 *
	 * @return void
	 */
	public function save()
	{
		
		//JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));

		$db = JFactory::getDBO();
		$query = $db->getQuery(true);	
		
		$chimp = new FourdemHelperChimp;

		$input = JFactory::getApplication()->input;
		$form = $input->get('jform', '', 'array');

		if (isset($form['groups']))
		{
			foreach ($form['groups'] as $key => $group)
			{
				$mergeVars[$key] = $group;
			}
		}

		$email = $form['form']['EMAIL'];
		
		//$mergeVars['OPTINIP'] = $_SERVER['REMOTE_ADDR'];

		$listId = $form['listid'];
		$autosync = $form['autosync'];

		if($autosync=='0')
		{
				$query->insert('#__fourdem_users')->columns('list_id,email,merges')
					->values($db->quote($listId) . ',' . $db->quote($email) . ',' . $db->quote(json_encode($mergeVars)));
				$db->setQuery($query);
				$db->query();
				$updated = false;
				$response['html'] = ($updated) ? 'updated' : 'saved';
				$response['error'] = false;
		}
		else
		{
				// Se ho impostato AutoSynch faccio un tentativo di iscrizione: se funziona bene altrimenti faccio una insert nel DB 
				$data=	$chimp->listSubscribe($listId, $email, $mergeVars, 'html', true, true, true, false);
				if ($data['errorCode'])
				{
					$response['html'] = $data['errorMessage'];
					$response['error'] = true;
					$updated = true;
				}
				else
				{
					$updated = false;
					if ($updated == false)
					{
						//Ho fatto una nuova registrazione --> inserisco il dato nella tabella
						$query->insert('#__fourdem_users')->columns('list_id,email,merges')
							->values($db->quote($listId) . ',' . $db->quote($email) . ',' . $db->quote(json_encode($mergeVars)));
						$db->setQuery($query);
						$db->query();
					}
					else
					{
						//L'utente era già registrato alla newsletter --> aggiorno la tabella di appoggio 
						$query->update('#__fourdem_users')->set('merges = ' . $db->quote(json_encode($mergeVars)))
							->where('email = ' . $db->quote($email) . ' AND list_id = ' . $db->quote($listId));
						$db->setQuery($query);
						$db->query();
					}

					$response['html'] = ($updated) ? 'updated' : 'saved';
					$response['error'] = false;
				}
		
		}
		echo json_encode($response);
	}
}